diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_buf.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_buf.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_buf.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_buf.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,293 @@
+#include "bsdtar_platform.h"
+
+#include <sys/socket.h>
+#include <sys/time.h>
+
+#include <signal.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "tsnetwork_internal.h"
+#include "tarsnap_opt.h"
+#include "tvmath.h"
+#include "warnp.h"
+
+#include "tsnetwork.h"
+
+/*
+ * If MSG_NOSIGNAL isn't defined, define it to zero; and then fiddle with
+ * the socket options when needed.
+ */
+#ifdef MSG_NOSIGNAL
+#define HAVE_MSG_NOSIGNAL
+#endif
+#ifndef HAVE_MSG_NOSIGNAL
+#define MSG_NOSIGNAL 0
+#endif
+
+struct network_buf_cookie {
+	network_callback * callback;
+	void * cookie;
+	int fd;
+	uint8_t * buf;
+	size_t buflen;
+	size_t bufpos;
+	struct timeval timeout;
+	struct timeval timeout_max;
+	ssize_t (* sendrecv)(int, void *, size_t, int);
+	int netop;
+	int flags;
+};
+
+static int callback_buf(void * cookie, int timedout);
+static int network_buf(int fd, uint8_t * buf, size_t buflen,
+    struct timeval * to0, struct timeval * to1,
+    network_callback * callback, void * cookie,
+    ssize_t (* sendrecv)(int, void *, size_t, int), int netop, int flags);
+
+/**
+ * callback_buf(cookie, status):
+ * Callback helper for tsnetwork_read and network_write.
+ */
+static int
+callback_buf(void * cookie, int status)
+{
+	struct network_buf_cookie * C = cookie;
+	struct timeval timeo;
+	size_t bwlimit;
+	size_t oplen;
+	ssize_t len;
+	int rc = -1;	/* If not callback or reset, we have an error. */
+#ifndef HAVE_MSG_NOSIGNAL
+#ifdef SO_NOSIGPIPE
+	int val;
+#else
+	void (*oldsig)(int);
+#endif
+#endif
+
+	if (status != NETWORK_STATUS_OK) {
+		/* If we have no data, mark a timeout as "no data" instead. */
+		if ((C->bufpos != 0) && (status == NETWORK_STATUS_TIMEOUT))
+			status = NETWORK_STATUS_NODATA;
+		goto docallback;
+	}
+
+	/* Figure out how far we have bandwidth quota for. */
+	if (network_bwlimit_get(C->netop, &bwlimit)) {
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+
+	/* If we have no bandwidth, schedule another callback. */
+	if (bwlimit == 0)
+		goto tryagain;
+
+	/* Try to read/write data to/from the buffer. */
+#ifndef HAVE_MSG_NOSIGNAL
+#ifdef SO_NOSIGPIPE
+	val = 1;
+
+	if (setsockopt(C->fd, SOL_SOCKET, SO_NOSIGPIPE, &val, sizeof(int))) {
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+#else
+	if ((oldsig = signal(SIGPIPE, SIG_IGN)) == SIG_ERR) {
+		warnp("signal(SIGPIPE)");
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+#endif
+#endif
+
+	oplen = C->buflen - C->bufpos;
+	if (oplen > bwlimit)
+		oplen = bwlimit;
+	len = (C->sendrecv)(C->fd, C->buf + C->bufpos, oplen, C->flags);
+#ifndef HAVE_MSG_NOSIGNAL
+#ifdef SO_NOSIGPIPE
+	val = 0;
+
+	if (setsockopt(C->fd, SOL_SOCKET, SO_NOSIGPIPE, &val, sizeof(int))) {
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+#else
+	if (signal(SIGPIPE, oldsig) == SIG_ERR) {
+		warnp("signal(SIGPIPE)");
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+#endif
+#endif
+
+	/* Failure, closed, or success? */
+	if (len == -1) {
+		/* If no data is available, reset the callback. */
+		if ((errno == EAGAIN) ||
+		    (errno == EWOULDBLOCK) ||
+		    (errno == EINTR))
+			goto tryagain;
+
+		/* An error occurred.  Let the callback handle it. */
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	} else if (len == 0) {
+		/* Socket has been shut down by remote host. */
+		/* This should occur only when receiving, not when sending. */
+		status = NETWORK_STATUS_CLOSED;
+		goto docallback;
+	} else {
+		/* Adjust bandwidth limit. */
+		if (network_bwlimit_eat(C->netop, len)) {
+			status = NETWORK_STATUS_ERR;
+			goto docallback;
+		}
+
+		/* Data has been read/written into/from buffer. */
+		C->bufpos += len;
+		if (C->bufpos == C->buflen) {
+			status = NETWORK_STATUS_OK;
+			goto docallback;
+		}
+
+		/* Fall through to resetting the callback. */
+	}
+
+tryagain:
+	/* We need more data.  Reset the callback. */
+	memcpy(&timeo, &C->timeout, sizeof(struct timeval));
+	if (tvmath_subctime(&timeo)) {
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+	if (tv_lt(&C->timeout_max, &timeo))
+		memcpy(&timeo, &C->timeout_max, sizeof(struct timeval));
+	if (network_register(C->fd, C->netop, &timeo, callback_buf, C)) {
+		status = NETWORK_STATUS_ERR;
+		goto docallback;
+	}
+
+	/* Callback has been reset. */
+	return (0);
+
+docallback:
+	/*
+	 * If there was a network error and we're being verbose, print the
+	 * error now in case errno gets mangled later.
+	 */
+	if ((tarsnap_opt_noisy_warnings) && (status == NETWORK_STATUS_ERR))
+		warnp("Network error");
+
+	/* Call the user callback. */
+	rc = (C->callback)(C->cookie, status);
+
+	/* Free the cookie. */
+	free(C);
+
+	/* Return error or value from user callback. */
+	return (rc);
+}
+
+/**
+ * network_buf(fd, buf, buflen, to0, to1, callback, cookie, sendrecv, netop,
+ *     flags):
+ * Asynchronously read/write the provided buffer from/to ${fd}, and call
+ * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
+ * out if no data can be read/writ for a period of time to0, or if the
+ * complete buffer has not been read/writ after time to1.
+ */
+static int
+network_buf(int fd, uint8_t * buf, size_t buflen,
+    struct timeval * to0, struct timeval * to1,
+    network_callback * callback, void * cookie,
+    ssize_t (* sendrecv)(int, void *, size_t, int), int netop,
+    int flags)
+{
+	struct network_buf_cookie * C;
+	struct timeval timeo;
+
+	/* Create a cookie to be passed to callback_buf. */
+	if ((C = malloc(sizeof(struct network_buf_cookie))) == NULL)
+		goto err0;
+	C->callback = callback;
+	C->cookie = cookie;
+	C->fd = fd;
+	C->buf = buf;
+	C->buflen = buflen;
+	C->bufpos = 0;
+	C->sendrecv = sendrecv;
+	C->netop = netop;
+	C->flags = flags;
+
+	/* Figure out when we should give up waiting. */
+	memcpy(&C->timeout, to1, sizeof(struct timeval));
+	if (tvmath_addctime(&C->timeout))
+		goto err1;
+
+	/* Record the maximum time that any single send/recv will wait. */
+	memcpy(&C->timeout_max, to0, sizeof(struct timeval));
+
+	/* Set up the callback. */
+	memcpy(&timeo, to1, sizeof(struct timeval));
+	if (tv_lt(to0, &timeo))
+		memcpy(&timeo, to0, sizeof(struct timeval));
+	if (network_register(fd, netop, &timeo, callback_buf, C))
+		goto err1;
+
+	/* Success! */
+	return (0);
+
+err1:
+	free(C);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * tsnetwork_read(fd, buf, buflen, to0, to1, callback, cookie):
+ * Asynchronously fill the provided buffer with data from ${fd}, and call
+ * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
+ * out if no data can be read for a period of time to0, or if the complete
+ * buffer has not been read after time to1.  Note that ${buflen} must be
+ * non-zero, since otherwise deadlock would result.
+ */
+int
+tsnetwork_read(int fd, uint8_t * buf, size_t buflen,
+    struct timeval * to0, struct timeval * to1,
+    network_callback * callback, void * cookie)
+{
+
+	/* Make sure buflen is non-zero. */
+	if (buflen == 0) {
+		warn0("Cannot read zero-byte buffer");
+		return (-1);
+	}
+
+	return (network_buf(fd, buf, buflen, to0, to1, callback, cookie,
+	    recv, NETWORK_OP_READ, 0));
+}
+
+/**
+ * tsnetwork_write(fd, buf, buflen, to0, to1, callback, cookie):
+ * Asynchronously write data from the provided buffer to ${fd}, and call
+ * callback(cookie, status) where status is a NETWORK_STATUS_* value.  Time
+ * out if no data can be written for a period of time to0, or if the complete
+ * buffer has not been written after time to1.  If ${buflen} is zero, the
+ * callback will be invoked with a status of NETWORK_STATUS_CLOSED, even if
+ * the connection is still open.
+ */
+int
+tsnetwork_write(int fd, const uint8_t * buf, size_t buflen,
+    struct timeval * to0, struct timeval * to1,
+    network_callback * callback, void * cookie)
+{
+
+	return (network_buf(fd, (uint8_t *)(uintptr_t)buf, buflen,
+	    to0, to1, callback, cookie,
+	    (ssize_t (*)(int, void *, size_t, int))send, NETWORK_OP_WRITE,
+	    MSG_NOSIGNAL));
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_bwlimit.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_bwlimit.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_bwlimit.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_bwlimit.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,241 @@
+#include <string.h>
+
+#include "events.h"
+#include "monoclock.h"
+
+#include "tsnetwork.h"
+#include "tsnetwork_internal.h"
+
+/* Bandwidth limiting state. */
+struct bwlimit {
+	double Bps;
+	double bucket;
+	void * timer_cookie;
+	int suspended;
+};
+static struct bwlimit limit_read;
+static struct bwlimit limit_write;
+
+/* Last time tokens were added to buckets. */
+static struct timeval tlast;
+static int tlast_set = 0;
+
+/* Initialized? */
+static int initdone = 0;
+
+/* Update the internal state. */
+static int poke(void);
+
+/* Initialize if necessary. */
+static void
+init(void)
+{
+
+	/* Limit to 1 GBps by default. */
+	limit_read.Bps = 1000000000.0;
+
+	/* 2s burst. */
+	limit_read.bucket = 2 * limit_read.Bps;
+
+	/* No timer yet. */
+	limit_read.timer_cookie = NULL;
+
+	/* Traffic not suspended. */
+	limit_read.suspended = 0;
+
+	/* Write state is the same as the read state. */
+	memcpy(&limit_write, &limit_read, sizeof(struct bwlimit));
+
+	/* We've been initialized! */
+	initdone = 1;
+}
+
+/* Timer wakeup. */
+static int
+callback_timer(void * cookie)
+{
+	struct bwlimit * l = cookie;
+
+	/* This timer is no longer running. */
+	l->timer_cookie = NULL;
+
+	/* Update state. */
+	return (poke());
+}
+
+/* Update the state for one direction. */
+static int
+pokeone(struct bwlimit * l, double t, int op)
+{
+	double waketime;
+
+	/* Add tokens to the bucket. */
+	l->bucket += l->Bps * t;
+
+	/* Overflow the bucket at 2 seconds of bandwidth. */
+	if (l->bucket > 2 * l->Bps)
+		l->bucket = 2 * l->Bps;
+
+	/* Do we need to re-enable traffic? */
+	if ((l->bucket >= 1460) && (l->suspended != 0)) {
+		/* Allow traffic to pass. */
+		if (network_register_resume(op))
+			goto err0;
+		l->suspended = 0;
+	}
+
+	/* Do we need to block traffic? */
+	if ((l->bucket < 1460) && (l->suspended == 0)) {
+		/* Stop traffic from running. */
+		if (network_register_suspend(op))
+			goto err0;
+		l->suspended = 1;
+	}
+
+	/* If traffic is running, we don't need a timer. */
+	if ((l->suspended == 0) && (l->timer_cookie != NULL)) {
+		events_timer_cancel(l->timer_cookie);
+		l->timer_cookie = NULL;
+	}
+
+	/* If traffic is suspended, we need a timer. */
+	if ((l->suspended == 1) && (l->timer_cookie == NULL)) {
+		/* Wait 10 ms or for 1460 bytes of quota. */
+		waketime = (1460 - l->bucket) / l->Bps;
+		if (waketime < 0.01)
+			waketime = 0.01;
+
+		/* Register a timer. */
+		if ((l->timer_cookie =
+		    events_timer_register_double(callback_timer,
+		    l, waketime)) == NULL)
+			goto err0;
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/* Update the internal state. */
+static int
+poke(void)
+{
+	struct timeval tnow;
+	double t;
+
+	/* Get the current time. */
+	if (monoclock_get(&tnow))
+		goto err0;
+
+	/* Compute the duration since the last poke. */
+	if (tlast_set)
+		t = (tnow.tv_sec - tlast.tv_sec) +
+		    (tnow.tv_usec - tlast.tv_usec) * 0.000001;
+	else
+		t = 0.0;
+
+	/* Poke each direction. */
+	if (pokeone(&limit_read, t, NETWORK_OP_READ))
+		goto err0;
+	if (pokeone(&limit_write, t, NETWORK_OP_WRITE))
+		goto err0;
+
+	/* We have been poked. */
+	memcpy(&tlast, &tnow, sizeof(struct timeval));
+	tlast_set = 1;
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_bwlimit(down, up):
+ * Set the bandwidth rate limit to ${down} bytes per second of read bandwidth
+ * and ${up} bytes per second of write bandwidth.  The values ${down} and
+ * ${up} must be between 8000 and 10^9.
+ */
+void
+network_bwlimit(double down, double up)
+{
+
+	/* Initialize if necessary. */
+	if (!initdone)
+		init();
+
+	/* Record these values for future reference. */
+	limit_read.Bps = down;
+	limit_write.Bps = up;
+
+	/* Don't allow more than a 2 s burst. */
+	if (limit_read.bucket > 2 * limit_read.Bps)
+		limit_read.bucket = 2 * limit_read.Bps;
+	if (limit_write.bucket > 2 * limit_write.Bps)
+		limit_write.bucket = 2 * limit_write.Bps;
+}
+
+/**
+ * network_bwlimit_get(op, len):
+ * Get the amount of instantaneously allowed bandwidth for ${op} operations.
+ */
+int
+network_bwlimit_get(int op, size_t * len)
+{
+
+	/* Initialize if necessary. */
+	if (!initdone)
+		init();
+
+	/* Update state. */
+	if (poke())
+		goto err0;
+
+	/* Return the appropriate value. */
+	if (op == NETWORK_OP_READ)
+		*len = limit_read.bucket;
+	else
+		*len = limit_write.bucket;
+
+	/*
+	 * If the allowed bandwidth is less than one normal-sized TCP segment,
+	 * force it to zero, in order to avoid silly windowing.
+	 */
+	if (*len < 1460)
+		*len = 0;
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_bwlimit_eat(op, len):
+ * Consume ${len} bytes of bandwidth quota for ${op} operations.
+ */
+int
+network_bwlimit_eat(int op, size_t len)
+{
+
+	/* Initialize if necessary. */
+	if (!initdone)
+		init();
+
+	/* Eat tokens from the bucket. */
+	if (op == NETWORK_OP_READ)
+		limit_read.bucket -= len;
+	else
+		limit_write.bucket -= len;
+
+	/* Update state. */
+	return (poke());
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_connect.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_connect.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_connect.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_connect.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,169 @@
+#include "bsdtar_platform.h"
+
+#include <sys/types.h>
+#include <sys/socket.h>
+
+#include <errno.h>
+#include <fcntl.h>
+#include <stdlib.h>
+
+#include "warnp.h"
+
+#include "tsnetwork.h"
+
+struct network_connect_cookie {
+	int s;
+	int failed;
+	int errnum;
+	network_callback * callback;
+	void * cookie;
+};
+
+static network_callback callback_connect;
+
+/**
+ * callback_connect(cookie, status):
+ * Callback helper for tsnetwork_connect.
+ */
+static int
+callback_connect(void * cookie, int status)
+{
+	struct network_connect_cookie * C = cookie;
+	int sockerr;
+	socklen_t sockerrlen = sizeof(int);
+	int rc;
+
+	/*
+	 * A timeout here is either a connection timeout or a connection
+	 * error, depending upon whether we got here as a result of a zero
+	 * second timeout used to postpone handling of a connect() failure.
+	 */
+	if (status == NETWORK_STATUS_TIMEOUT) {
+		if (C->failed) {
+			/*
+			 * The connect() call returned an error; restore the
+			 * errno value from that point so that when we invoke
+			 * our callback we have the right value there.
+			 */
+			status = NETWORK_STATUS_CONNERR;
+			errno = C->errnum;
+		} else {
+			/*
+			 * There was a connection timeout; set errno to zero
+			 * here since any value in errno at this point is
+			 * just left over from a previous failed syscall.
+			 */
+			status = NETWORK_STATUS_CTIMEOUT;
+			errno = 0;
+		}
+	}
+
+	if (status != NETWORK_STATUS_OK)
+		goto docallback;
+
+	/* Even if the status is ok, we need to check for pending error. */
+	if (getsockopt(C->s, SOL_SOCKET, SO_ERROR, &sockerr, &sockerrlen)) {
+		status = NETWORK_STATUS_CONNERR;
+		goto docallback;
+	}
+	if (sockerr != 0) {
+		errno = sockerr;
+		status = NETWORK_STATUS_CONNERR;
+	}
+
+docallback:
+	/* Call the upstream callback. */
+	rc = (C->callback)(C->cookie, status);
+
+	/* Free the cookie. */
+	free(C);
+
+	/* Return value from user callback. */
+	return (rc);
+}
+
+/**
+ * tsnetwork_connect(s, addr, addrlen, timeout, callback, cookie):
+ * Connect the specified socket to the specified address, and call the
+ * specified callback when connected or the connection attempt has failed.
+ */
+int
+tsnetwork_connect(int s, const struct sockaddr * addr, socklen_t addrlen,
+    struct timeval * timeout, network_callback * callback, void * cookie)
+{
+	struct network_connect_cookie * C;
+	struct timeval timeo;
+	int rc = 0;	/* Success unless specified otherwise. */
+
+	/* Create a cookie to be passed to callback_connect. */
+	if ((C = malloc(sizeof(struct network_connect_cookie))) == NULL)
+		goto err0;
+	C->s = s;
+	C->failed = 0;
+	C->callback = callback;
+	C->cookie = cookie;
+
+	/* Mark socket as non-blocking. */
+	if (fcntl(s, F_SETFL, O_NONBLOCK) == -1) {
+		warnp("fcntl(O_NONBLOCK)");
+		goto err1;
+	}
+
+	/* Try to connect to the server. */
+	if ((connect(s, addr, addrlen) == 0) ||
+	    (errno == EINPROGRESS) ||
+	    (errno == EINTR)) {
+		/* Connection is being established. */
+		if (network_register(s, NETWORK_OP_WRITE, timeout,
+		    callback_connect, C))
+			goto err1;
+	} else if ((errno == ECONNREFUSED) ||
+	    (errno == ECONNRESET) ||
+	    (errno == ENETDOWN) ||
+	    (errno == ENETUNREACH) ||
+#ifdef FREEBSD_PORTRANGE_BUG
+	/**
+	 * If FreeBSD's net.inet.ip.portrange.randomized sysctl is set to 1
+	 * (the default value) FreeBSD sometimes reuses a source port faster
+	 * than might naively be expected.  This doesn't cause any problems
+	 * except if the pf firewall is running on the source system; said
+	 * firewall detects the packet as belonging to an expired connection
+	 * and drops it.  This would be fine, except that the FreeBSD kernel
+	 * doesn't merely drop the packet when a firewall blocks an outgoing
+	 * packet; instead, it reports EPERM back to the userland process
+	 * which was responsible for the packet being sent.
+	 * In short, things interact in wacky ways which make it possible to
+	 * get EPERM back in response to a connect(2) syscall.  Work around
+	 * this by handling EPERM the same way as transient network glitches;
+	 * the upstream code will handle this appropriately by retrying the
+	 * connection, at which point a new source port number will be chosen
+	 * and everything will (probably) work fine.
+	 */
+	    (errno == EPERM) ||
+#endif
+	    (errno == EHOSTUNREACH)) {
+		/*
+		 * The connection attempt has failed.  Schedule a callback
+		 * to be performed after we return, since we're not allowed
+		 * to perform the callback right now.
+		 */
+		C->failed = 1;
+		C->errnum = errno;
+		timeo.tv_sec = timeo.tv_usec = 0;
+		if (network_sleep(&timeo, callback_connect, C))
+			goto err1;
+	} else {
+		/* Something went seriously wrong. */
+		warnp("Network connection failure");
+		goto err1;
+	}
+
+	/* Return success or the status from the callback. */
+	return (rc);
+
+err1:
+	free(C);
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_cork.c tarsnap-autoconf-1.0.34/lib/network/tsnetwork_cork.c
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_cork.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_cork.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,111 @@
+#include "bsdtar_platform.h"
+
+#include <sys/types.h>
+#include <sys/socket.h>
+
+#include <netinet/in.h>
+#include <netinet/tcp.h>
+
+#include "warnp.h"
+
+#include "tsnetwork_internal.h"
+
+/**
+ * XXX Portability
+ * XXX These functions serve two purposes:
+ * XXX 1. To avoid wasting bandwidth, by ensuring that multiple small writes
+ * XXX over a socket are aggregated into a single TCP/IP packet.
+ * XXX 2. To avoid severe performance issues which would otherwise result
+ * XXX from nagling, by allowing data to be "pushed" out once there are no
+ * XXX more writes queued.
+ * XXX
+ * XXX POSIX defines TCP_NODELAY for purpose #2, although it does not require
+ * XXX that implementations obey it; BSD and Linux respectively define
+ * XXX TCP_NOPUSH and TCP_CORK for purpose #1.  On OS X, TCP_NOPUSH is
+ * XXX defined, but seems to be broken; we use autoconf to detect OS X and
+ * XXX define BROKEN_TCP_NOPUSH.  On Cygwin, TCP_NOPUSH is defined, but
+ * XXX using it produces a ENOPROTOOPT error; we define BROKEN_TCP_NOPUSH
+ * XXX in this case, too.  On Minix, TCP_NODELAY fails with ENOSYS; since
+ * XXX corking occurs for performance reasons only, we ignore this errno.
+ */
+
+/* Macro to simplify setting options. */
+#define setopt(fd, opt, value, err0) do {				\
+	int val;							\
+									\
+	val = value;							\
+	if (setsockopt(fd, IPPROTO_TCP, opt, &val, sizeof(int))) {	\
+		if ((errno != ETIMEDOUT) &&				\
+		    (errno != ECONNRESET) &&				\
+		    (errno != ENOSYS)) {				\
+			warnp("setsockopt(%s, %d)", #opt, val);		\
+			goto err0;					\
+		}							\
+	}								\
+} while (0);
+
+/**
+ * network_cork(fd):
+ * Clear the TCP_NODELAY socket option, and set TCP_CORK or TCP_NOPUSH if
+ * either is defined.
+ */
+int
+network_cork(int fd)
+{
+
+	/* Clear TCP_NODELAY. */
+	setopt(fd, TCP_NODELAY, 0, err0);
+
+	/* Set TCP_CORK or TCP_NOPUSH as appropriate. */
+#ifdef TCP_CORK
+	setopt(fd, TCP_CORK, 1, err0);
+#else
+#ifdef TCP_NOPUSH
+#ifndef BROKEN_TCP_NOPUSH
+	setopt(fd, TCP_NOPUSH, 1, err0);
+#endif
+#endif
+#endif
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * network_uncork(fd):
+ * Set the TCP_NODELAY socket option, and clear TCP_CORK or TCP_NOPUSH if
+ * either is defined.
+ */
+int
+network_uncork(int fd)
+{
+
+	/* Clear TCP_CORK or TCP_NOPUSH as appropriate. */
+#ifdef TCP_CORK
+	setopt(fd, TCP_CORK, 0, err0);
+#else
+#ifdef TCP_NOPUSH
+#ifndef BROKEN_TCP_NOPUSH
+	setopt(fd, TCP_NOPUSH, 0, err0);
+#endif
+#endif
+#endif
+
+	/* Set TCP_NODELAY. */
+	/*
+	 * For compatibility with Linux 2.4, this must be done after we
+	 * clear TCP_CORK; otherwise it will throw an EINVAL back at us.
+	 */
+	setopt(fd, TCP_NODELAY, 1, err0);
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/lib/network/tsnetwork_internal.h tarsnap-autoconf-1.0.34/lib/network/tsnetwork_internal.h
--- tarsnap-autoconf-1.0.33/lib/network/tsnetwork_internal.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/lib/network/tsnetwork_internal.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,76 @@
+#ifndef _NETWORK_INTERNAL_H_
+#define _NETWORK_INTERNAL_H_
+
+/* Macros for handling struct timeval values. */
+#define tv_lt(a, b)				\
+	(((a)->tv_sec < (b)->tv_sec) ||		\
+	    (((a)->tv_sec == (b)->tv_sec) &&	\
+		((a)->tv_usec < (b)->tv_usec)))
+#define tv_add(a, b)	do {			\
+	(a)->tv_sec += (b)->tv_sec;		\
+	(a)->tv_usec += (b)->tv_usec;		\
+	if ((a)->tv_usec >= 1000000) {		\
+		(a)->tv_usec -= 1000000;	\
+		(a)->tv_sec += 1;		\
+	}					\
+} while (0)
+#define tv_sub(a, b)	do {			\
+	(a)->tv_sec -= (b)->tv_sec;		\
+	(a)->tv_usec -= (b)->tv_usec;		\
+	if ((a)->tv_usec < 0) {			\
+		(a)->tv_usec += 1000000;	\
+		(a)->tv_sec -= 1;		\
+	}					\
+} while (0)
+
+/**
+ * network_cork(fd):
+ * Clear the TCP_NODELAY socket option, and set TCP_CORK or TCP_NOPUSH if
+ * either is defined.
+ */
+int network_cork(int);
+
+/**
+ * network_uncork(fd):
+ * Set the TCP_NODELAY socket option, and clear TCP_CORK or TCP_NOPUSH if
+ * either is defined.
+ */
+int network_uncork(int);
+
+/**
+ * network_register_suspend(op):
+ * Suspend ${op} operations, on all file descriptors.
+ */
+int network_register_suspend(int);
+
+/**
+ * network_register_resume(op):
+ * Resume pending ${op} operations, on all file descriptors.
+ */
+int network_register_resume(int);
+
+/**
+ * network_register_fini(void):
+ * Free resources allocated.
+ */
+void network_register_fini(void);
+
+/**
+ * network_sleep_fini(void):
+ * Free resources allocated.
+ */
+void network_sleep_fini(void);
+
+/**
+ * network_bwlimit_get(op, len):
+ * Get the amount of instantaneously allowed bandwidth for ${op} operations.
+ */
+int network_bwlimit_get(int, size_t *);
+
+/**
+ * network_bwlimit_eat(op, len):
+ * Consume ${len} bytes of bandwidth quota for ${op} operations.
+ */
+int network_bwlimit_eat(int, size_t);
+
+#endif /* !_NETWORK_H_ */
